// this libary defines some Pins of the AKKON USB CNC Controller board

#ifndef _PICHARDW
#define _PICHARDW

// Reload for System Timer 
#define TMR1_RELOAD_1MS_LO			0x23   // postscaler 1500 
#define TMR1_RELOAD_1MS_HI			0xFA

#define TRIS_SW2 			PORTAbits.RA2
#define SW2					PORTAbits.RA2


// stepper motor control parameters
#define SMX_CLK 			PORTDbits.RD0
#define SMY_CLK 			PORTDbits.RD1
#define SMZ_CLK 			PORTDbits.RD2
#define SMC_CLK 			PORTDbits.RD3

#define SMX_DIR				PORTDbits.RD4
#define SMY_DIR				PORTDbits.RD5
#define SMZ_DIR				PORTDbits.RD6
#define SMC_DIR				PORTDbits.RD7

#define SMX_I	 			PORTAbits.RA0
#define SMY_I 				PORTAbits.RA1
#define SMZ_I				PORTAbits.RA2
#define SMC_I				PORTAbits.RA3

#define SM_ENABLE_ALL 		PORTEbits.RE1
#define SM_FULL		 		PORTEbits.RE2

#define bitM08				PORTCbits.RC1	
#define bitM10				PORTEbits.RE0

#define MIN_X		 		PORTBbits.RB2
#define MIN_Y		 		PORTBbits.RB3
#define MIN_Z		 		PORTBbits.RB4
#define MAX_X		 		PORTBbits.RB5
#define MAX_Y		 		PORTBbits.RB6
#define MAX_Z		 		PORTBbits.RB7


#define BTN_EMERGENCY		PORTAbits.RA5
#define HALL_SENSOR_IN		PORTCbits.RC0
#define PWM_SPINDLE			PORTCbits.RC2

//RS232 
#define TRIS_TX_RS232		TRISCbits.TRISC6
#define TRIS_RX_RS232		TRISCbits.TRISC7


// Configuration IO pins
#define TRIS_SMX_CLK 		TRISDbits.TRISD0
#define TRIS_SMY_CLK 		TRISDbits.TRISD1
#define TRIS_SMZ_CLK 		TRISDbits.TRISD2
#define TRIS_SMC_CLK 		TRISDbits.TRISD3

#define TRIS_SMX_DIR		TRISDbits.TRISD4
#define TRIS_SMY_DIR		TRISDbits.TRISD5
#define TRIS_SMZ_DIR		TRISDbits.TRISD6
#define TRIS_SMC_DIR		TRISDbits.TRISD7

#define TRIS_SMX_IMIN 		TRISAbits.TRISA0
#define TRIS_SMY_IMIN 		TRISAbits.TRISA1
#define TRIS_SMZ_IMIN		TRISAbits.TRISA2
#define TRIS_SMC_IMIN		TRISAbits.TRISA3

#define TRIS_SM_ENABLE_ALL 	TRISEbits.TRISE1
#define TRIS_SM_FULL	 	TRISEbits.TRISE0

#define TRIS_M08			TRISCbits.TRISC1
#define TRIS_M10			TRISEbits.TRISE0
#define TRIS_BTN_EMERGENCY  TRISAbits.TRISA5	// digitaler Eingangs des Notaus-Tasters/Schalters
#define TRIS_PWM_SPINDLE	TRISCbits.TRISC2
#define TRIS_HALL_SENSOR_IN TRISCbits.TRISC0

#define TRIS_MIN_X		 	TRISBbits.TRISB2
#define TRIS_MIN_Y			TRISBbits.TRISB3
#define TRIS_MIN_Z		 	TRISBbits.TRISB4
#define TRIS_MAX_X		 	TRISBbits.TRISB5
#define TRIS_MAX_Y		 	TRISBbits.TRISB6
#define TRIS_MAX_Z		 	TRISBbits.TRISB7

#define END_POSX_MIN		0x04
#define END_POSY_MIN		0x08
#define END_POSZ_MIN		0x10

#define END_POSX_MAX		0x20
#define END_POSY_MAX		0x40
#define END_POSZ_MAX		0x80

extern volatile unsigned long SysTicks;  // Systemuhr 1ms

/****************************************************************************/
/* function prototypes                                                      */
/****************************************************************************/
void InituPHardW(void);

// read limit switches
unsigned char GetLimitSwitchState(void);

void InitRS232(void);
char ReceiveSerial(unsigned char *data);
void SendString(unsigned char *ch);
void TXbyte(unsigned char data);
#endif
